/* ******************************************************************************
 *
 *
 * This program and the accompanying materials are made available under the
 * terms of the Apache License, Version 2.0 which is available at
 * https://www.apache.org/licenses/LICENSE-2.0.
 *
 *  See the NOTICE file distributed with this work for additional
 *  information regarding copyright ownership.
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 ******************************************************************************/

//
// Created by raver119 on 20.10.2017.
//

#ifndef LIBND4J_LOGICWHILE_H
#define LIBND4J_LOGICWHILE_H

#include <system/pointercast.h>
#include <graph/Node.h>
#include <graph/Graph.h>

namespace sd {
    namespace graph {
        /**
         * This class is responsible for execution logic of While logical abstraction
         *
         * Basic idea is simple: we take 2 scopes, one for condition and other one for body. and we re-execute body as long, as condition scope evaluates to TRUE
         * @tparam T
         */
        class LogicWhile {
        public:
            static Nd4jStatus processNode(Graph* graph, Node* node);
        };
    }
}


#endif //LIBND4J_LOGICWHILE_H
